diff --git a/test/unit/daemon/auto_retry/classifier_test.rb b/test/unit/daemon/auto_retry/classifier_test.rb
new file mode 100644
index 00000000..6fabcdd2
--- /dev/null
+++ b/test/unit/daemon/auto_retry/classifier_test.rb
@@ -0,0 +1,445 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "fileutils"
+require "hive/daemon/auto_retry/classifier"
+require "hive/daemon/auto_retry/evidence"
+require "hive/task_action"
+
+class DaemonAutoRetryClassifierTest < Minitest::Test
+  FIXTURES = File.expand_path("../../../fixtures/auto_retry", __dir__)
+
+  def classifier(**kwargs)
+    Hive::Daemon::AutoRetry::Classifier.classify(**kwargs)
+  end
+
+  def row(stage: "4-execute", reason: "implementer_failed", message: nil, marker_id: "abc123",
+          marker: "error", attrs: nil)
+    base = { "reason" => reason, "marker_id" => marker_id }
+    base["message"] = message if message
+    base.merge!(attrs) if attrs
+    {
+      marker: marker,
+      marker_attrs: base,
+      stage: stage,
+      project: "demo",
+      slug: "task-slug-260512-abcd",
+      folder: "/tmp/fake"
+    }
+  end
+
+  def codex_config
+    { "execute" => { "agent" => "codex" }, "claude" => { "mode" => "tmux" } }
+  end
+
+  def claude_config(mode: "tmux")
+    {
+      "execute" => { "agent" => "claude" },
+      "brainstorm" => { "agent" => "claude" },
+      "plan" => { "agent" => "claude" },
+      "claude" => { "mode" => mode }
+    }
+  end
+
+  def evidence_from_fixture(*parts)
+    path = File.join(FIXTURES, *parts)
+    text = File.read(path)
+    { text: text, kind: :log, fresh: true, marker_signature_match: true }
+  end
+
+  # ── Codex auth ──────────────────────────────────────────────────────────
+
+  def test_task58_missing_bearer_classifies_as_codex_auth
+    result = classifier(
+      row: row(message: "unexpected status 401 Unauthorized: missing bearer authentication"),
+      config: codex_config,
+      evidence: evidence_from_fixture("task-58", "agent.log"),
+      execute_agent: "codex"
+    )
+
+    assert result.eligible?
+    assert_equal :codex_auth_401, result.recovery_class
+  end
+
+  def test_task58_basic_auth_variant_classifies
+    result = classifier(
+      row: row,
+      config: codex_config,
+      evidence: evidence_from_fixture("task-58", "basic-auth.log"),
+      execute_agent: "codex"
+    )
+
+    assert result.eligible?
+    assert_equal :codex_auth_401, result.recovery_class
+  end
+
+  def test_generic_exit_code_1_is_ineligible
+    result = classifier(
+      row: row(attrs: { "exit_code" => "1", "reason" => "exit_code" }),
+      config: codex_config,
+      evidence: evidence_from_fixture("near_miss", "generic-exit-1.log"),
+      execute_agent: "codex"
+    )
+
+    refute result.eligible?
+    assert_equal "unknown_reason", result.rationale
+  end
+
+  def test_unrelated_401_is_ineligible
+    result = classifier(
+      row: row,
+      config: codex_config,
+      evidence: evidence_from_fixture("near_miss", "unrelated-401.log"),
+      execute_agent: "codex"
+    )
+
+    refute result.eligible?
+    assert_equal "unknown_signature", result.rationale
+  end
+
+  def test_non_auth_401_text_is_ineligible
+    result = classifier(
+      row: row,
+      config: codex_config,
+      evidence: { text: "HTTP 401 from internal metrics service", kind: :log,
+                  fresh: true, marker_signature_match: true },
+      execute_agent: "codex"
+    )
+
+    refute result.eligible?
+    assert_equal "unknown_signature", result.rationale
+  end
+
+  def test_unauthorized_auth_wording_without_http_401_is_ineligible
+    result = classifier(
+      row: row(message: "Unauthorized: missing bearer authentication"),
+      config: codex_config,
+      evidence: { text: "Unauthorized: missing bearer authentication", kind: :marker,
+                  fresh: true, marker_signature_match: true },
+      execute_agent: "codex"
+    )
+
+    refute result.eligible?
+    assert_equal "unknown_signature", result.rationale
+  end
+
+  def test_claude_execute_profile_rejects_codex_auth
+    result = classifier(
+      row: row(message: "401 Unauthorized missing bearer authentication"),
+      config: claude_config,
+      evidence: evidence_from_fixture("task-58", "agent.log"),
+      execute_agent: "claude"
+    )
+
+    refute result.eligible?
+    assert_equal "wrong_provider", result.rationale
+  end
+
+  def test_missing_diagnostics_ineligible
+    result = classifier(
+      row: row,
+      config: codex_config,
+      evidence: { text: "", kind: nil, fresh: true, marker_signature_match: true },
+      execute_agent: "codex"
+    )
+
+    refute result.eligible?
+    assert_equal "missing_diagnostic", result.rationale
+  end
+
+  def test_stale_diagnostic_ineligible
+    result = classifier(
+      row: row(message: "401 Unauthorized missing bearer authentication"),
+      config: codex_config,
+      evidence: { text: "401 missing bearer", kind: :red_status,
+                  fresh: false, marker_signature_match: false },
+      execute_agent: "codex"
+    )
+
+    refute result.eligible?
+    assert_equal "stale_diagnostic", result.rationale
+  end
+
+  def test_wrong_stage_for_codex_auth
+    result = classifier(
+      row: row(stage: "3-plan", message: "401 Unauthorized missing bearer authentication"),
+      config: codex_config,
+      evidence: evidence_from_fixture("task-58", "agent.log"),
+      execute_agent: "codex"
+    )
+
+    refute result.eligible?
+    assert_equal "wrong_stage", result.rationale
+  end
+
+  # ── Claude launcher ─────────────────────────────────────────────────────
+
+  def test_task287_launcher_fixture_classifies
+    result = classifier(
+      row: row(stage: "3-plan", reason: "claude_launch_failed",
+               message: "claude interactive prompt did not become ready"),
+      config: claude_config,
+      evidence: evidence_from_fixture("task-287", "launcher.log"),
+      stage_agent: "claude",
+      claude_mode: "tmux"
+    )
+
+    assert result.eligible?
+    assert_equal :claude_launcher, result.recovery_class
+  end
+
+  def test_claude_session_exists_excluded
+    result = classifier(
+      row: row(stage: "4-execute", reason: "claude_launch_failed",
+               message: "tmux session hive-foo already exists"),
+      config: claude_config,
+      evidence: evidence_from_fixture("near_miss", "claude-session-exists.log"),
+      stage_agent: "claude",
+      claude_mode: "tmux"
+    )
+
+    refute result.eligible?
+    assert_equal "excluded_signature", result.rationale
+  end
+
+  def test_claude_quota_message_excluded
+    result = classifier(
+      row: row(stage: "4-execute", reason: "claude_launch_failed"),
+      config: claude_config,
+      evidence: evidence_from_fixture("near_miss", "claude-quota.log"),
+      stage_agent: "claude",
+      claude_mode: "tmux"
+    )
+
+    refute result.eligible?
+    assert_equal "excluded_signature", result.rationale
+  end
+
+  def test_unrelated_claude_launch_failed_ineligible
+    result = classifier(
+      row: row(stage: "4-execute", reason: "claude_launch_failed",
+               message: "AgentError: mysterious failure XYZ"),
+      config: claude_config,
+      evidence: { text: "AgentError: mysterious failure XYZ", kind: :marker,
+                  fresh: true, marker_signature_match: true },
+      stage_agent: "claude",
+      claude_mode: "tmux"
+    )
+
+    refute result.eligible?
+    assert_equal "unknown_signature", result.rationale
+  end
+
+  def test_bare_claude_wrapper_name_is_ineligible
+    result = classifier(
+      row: row(stage: "3-plan", reason: "claude_launch_failed",
+               message: "interactive_claude_wrapper"),
+      config: claude_config,
+      evidence: { text: "interactive_claude_wrapper", kind: :marker,
+                  fresh: true, marker_signature_match: true },
+      stage_agent: "claude",
+      claude_mode: "tmux"
+    )
+
+    refute result.eligible?
+    assert_equal "unknown_signature", result.rationale
+  end
+
+  def test_headless_claude_mode_rejects_launcher
+    result = classifier(
+      row: row(stage: "4-execute", reason: "claude_launch_failed",
+               message: "claude interactive prompt did not become ready"),
+      config: claude_config(mode: "headless"),
+      evidence: evidence_from_fixture("task-287", "launcher.log"),
+      stage_agent: "claude",
+      claude_mode: "headless"
+    )
+
+    refute result.eligible?
+    assert_equal "wrong_claude_mode", result.rationale
+  end
+
+  def test_unsupported_stage_for_claude_launcher
+    result = classifier(
+      row: row(stage: "8-finalize", reason: "claude_launch_failed",
+               message: "claude interactive prompt did not become ready"),
+      config: claude_config,
+      evidence: evidence_from_fixture("task-287", "launcher.log"),
+      stage_agent: "claude",
+      claude_mode: "tmux"
+    )
+
+    refute result.eligible?
+    assert_equal "stage_not_supported", result.rationale
+  end
+
+  def test_brainstorm_claude_launcher_eligible
+    result = classifier(
+      row: row(stage: "2-brainstorm", reason: "claude_launch_failed",
+               message: "claude interactive prompt did not become ready"),
+      config: claude_config,
+      evidence: evidence_from_fixture("task-287", "launcher.log"),
+      stage_agent: "claude",
+      claude_mode: "tmux"
+    )
+
+    assert result.eligible?
+    assert_equal :claude_launcher, result.recovery_class
+  end
+
+  # ── Evidence loader fail-closed ─────────────────────────────────────────
+
+  def test_evidence_missing_folder_fails_closed
+    ev = Hive::Daemon::AutoRetry::Evidence.load(folder: "/nonexistent/path")
+    assert_equal :missing_folder, ev.error
+  end
+
+  def test_evidence_loads_log_and_classifies
+    Dir.mktmpdir("hive-auto-retry-ev") do |folder|
+      logs = File.join(folder, "logs")
+      FileUtils.mkdir_p(logs)
+      File.write(File.join(logs, "run.log"), File.read(File.join(FIXTURES, "task-58", "agent.log")))
+
+      state = File.join(folder, "task.md")
+      File.write(state, "<!-- ERROR reason=implementer_failed marker_id=deadbeef message=\"HTTP 401 missing bearer\" -->\n")
+
+      marker = Hive::Markers.current(state)
+      ev = Hive::Daemon::AutoRetry::Evidence.load(
+        folder: folder, state_file: state, marker: marker
+      )
+      refute_nil ev.text
+      assert_nil ev.error
+
+      result = classifier(
+        row: row(message: "HTTP 401 Unauthorized missing bearer authentication"),
+        config: codex_config,
+        evidence: ev.to_h,
+        execute_agent: "codex"
+      )
+      assert result.eligible?
+    end
+  end
+
+  def test_stale_red_status_signature_fails_closed
+    Dir.mktmpdir("hive-auto-retry-stale") do |folder|
+      diag = File.join(folder, "diagnostics")
+      FileUtils.mkdir_p(diag)
+      state = File.join(folder, "task.md")
+      File.write(state, "<!-- ERROR reason=implementer_failed marker_id=newid message=\"401 missing bearer\" -->\n")
+      marker = Hive::Markers.current(state)
+      wrong_sig = "0" * 64
+      File.write(File.join(diag, "red-status.md"), <<~MD)
+        ---
+        summary: 401 Unauthorized missing bearer authentication
+        generated_by: codex
+        marker_signature: #{wrong_sig}
+        ---
+        body
+      MD
+
+      # Make red-status newer than state so only signature mismatches
+      FileUtils.touch(File.join(diag, "red-status.md"), mtime: Time.now + 5)
+
+      ev = Hive::Daemon::AutoRetry::Evidence.load(
+        folder: folder, state_file: state, marker: marker
+      )
+      assert_equal :stale_diagnostic, ev.error
+
+      result = classifier(
+        row: row(message: "401 Unauthorized missing bearer authentication"),
+        config: codex_config,
+        evidence: ev.to_h,
+        execute_agent: "codex"
+      )
+      refute result.eligible?
+      assert_equal "stale_diagnostic", result.rationale
+    end
+  end
+
+  def test_unscoped_oversized_log_does_not_raise_or_become_evidence
+    Dir.mktmpdir("hive-auto-retry-big") do |folder|
+      logs = File.join(folder, "logs")
+      FileUtils.mkdir_p(logs)
+      # Write a large-ish log; loader must bound and not raise.
+      File.write(File.join(logs, "big.log"), ("x" * 100) + "\n401 Unauthorized missing bearer authentication\n")
+
+      ev = Hive::Daemon::AutoRetry::Evidence.load(folder: folder)
+      assert_equal :missing_diagnostic, ev.error
+    end
+  end
+
+  def test_symlink_evidence_fails_closed
+    Dir.mktmpdir("hive-auto-retry-sym") do |folder|
+      outside = File.join(folder, "outside.log")
+      File.write(outside, "401 Unauthorized missing bearer authentication\n")
+      logs = File.join(folder, "logs")
+      FileUtils.mkdir_p(logs)
+      # Symlink escapes should not be accepted as contained evidence when
+      # the realpath is still under folder (this one is inside folder but
+      # tests the File.file? / realpath path). Create a FIFO-like refusal
+      # via a directory named like a log.
+      FileUtils.mkdir_p(File.join(logs, "not-a-file.log"))
+
+      ev = Hive::Daemon::AutoRetry::Evidence.load(folder: folder)
+      # No valid log evidence → missing
+      assert_equal :missing_diagnostic, ev.error
+    end
+  end
+
+  def test_unscoped_invalid_utf8_log_does_not_raise_or_become_evidence
+    Dir.mktmpdir("hive-auto-retry-utf8") do |folder|
+      logs = File.join(folder, "logs")
+      FileUtils.mkdir_p(logs)
+      File.open(File.join(logs, "bad.log"), "wb") do |f|
+        f.write("401 Unauthorized missing bearer authentication\n".b)
+        f.write("\xFF\xFE bad bytes\n".b)
+      end
+
+      ev = Hive::Daemon::AutoRetry::Evidence.load(folder: folder)
+      assert_equal :missing_diagnostic, ev.error
+    end
+  end
+
+  def test_old_log_from_prior_marker_episode_is_not_used
+    Dir.mktmpdir("hive-auto-retry-old-log") do |folder|
+      logs = File.join(folder, "logs")
+      FileUtils.mkdir_p(logs)
+      log = File.join(logs, "run.log")
+      File.write(log, "HTTP 401 Unauthorized missing bearer authentication\n")
+      FileUtils.touch(log, mtime: Time.now - 601)
+      state = File.join(folder, "task.md")
+      File.write(state, "<!-- ERROR reason=implementer_failed marker_id=current message=\"agent failed\" -->\n")
+
+      ev = Hive::Daemon::AutoRetry::Evidence.load(folder: folder, state_file: state,
+                                                   marker_attrs: { "marker_id" => "current" })
+      assert_equal :marker, ev.kind
+      refute_includes ev.text, "401"
+
+      result = classifier(row: row(message: "agent failed", marker_id: "current"),
+                          config: codex_config, evidence: ev.to_h, execute_agent: "codex")
+      refute result.eligible?
+    end
+  end
+
+  def test_unknown_reason_audit_rationale
+    result = classifier(
+      row: row(reason: "dirty_worktree"),
+      config: codex_config,
+      evidence: { text: "dirty", kind: :marker, fresh: true, marker_signature_match: true },
+      execute_agent: "codex"
+    )
+    refute result.eligible?
+    assert_equal "unknown_reason", result.rationale
+  end
+
+  def test_not_error_marker
+    result = classifier(
+      row: row(marker: "review_error", reason: "implementer_failed"),
+      config: codex_config,
+      evidence: evidence_from_fixture("task-58", "agent.log"),
+      execute_agent: "codex"
+    )
+    refute result.eligible?
+    assert_equal "not_error_marker", result.rationale
+  end
+end
diff --git a/test/unit/daemon/auto_retry/coordinator_test.rb b/test/unit/daemon/auto_retry/coordinator_test.rb
new file mode 100644
index 00000000..0a71f64d
--- /dev/null
+++ b/test/unit/daemon/auto_retry/coordinator_test.rb
@@ -0,0 +1,362 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "tmpdir"
+require "fileutils"
+require "hive/daemon/auto_retry/coordinator"
+require "hive/daemon/auto_retry/state"
+require "hive/daemon/auto_retry/health"
+require "hive/daemon/status_consumer"
+
+class DaemonAutoRetryCoordinatorTest < Minitest::Test
+  Row = Hive::Daemon::StatusConsumer::Row
+
+  class FakeLogger
+    attr_reader :events
+    def initialize = @events = []
+    def event(name, **attrs) = @events << [ name, attrs ]
+  end
+
+  class FakeController
+    def running_task?(**) = false
+  end
+
+  class FakeQueue
+    attr_reader :requests, :sequences
+    attr_accessor :fail_sequence
+    def initialize
+      @requests = []
+      @sequences = {}
+      @fail_sequence = false
+    end
+    def pending = []
+    def request_exists?(id, state_home: nil)
+      @requests.any? { |request| request[:request_id].to_s == id.to_s }
+    end
+    def write_request!(**kwargs)
+      @requests << kwargs
+      kwargs[:request_id] || "req-#{@requests.size}"
+    end
+    def write_sequence!(id, remaining_argvs:, state_home: nil, recovery_id: nil)
+      raise IOError, "sequence write failed" if @fail_sequence
+
+      @sequences[id] = { argvs: remaining_argvs, recovery_id: recovery_id }
+      true
+    end
+    def remove_if_unclaimed(*) = true
+  end
+
+  class FakeHealth
+    attr_reader :probe_count
+    attr_accessor :healthy, :fingerprint, :signal
+
+    def initialize(healthy: true, fingerprint: "fp-healthy")
+      @healthy = healthy
+      @fingerprint = fingerprint
+      @signal = "signal-#{fingerprint}"
+      @probe_count = 0
+    end
+    def reset_tick_cache!; end
+    def signal_fingerprint(**) = @signal
+    def probe(**)
+      @probe_count += 1
+      Hive::Daemon::AutoRetry::Health::ProbeSetResult.new(
+        healthy: @healthy, fingerprint: @fingerprint,
+        probes: [ { "name" => "x", "ok" => @healthy, "timed_out" => false,
+                    "duration_sec" => 0.25, "stdout" => "safe excerpt" } ],
+        rationale: @healthy ? "healthy" : "probe_failed", correlation_id: "c1"
+      )
+    end
+  end
+
+  def setup
+    @logger = FakeLogger.new
+    @queue = FakeQueue.new
+    @dir = Dir.mktmpdir("hive-coord")
+    @state = Hive::Daemon::AutoRetry::State.new(path: File.join(@dir, "state.json"))
+  end
+
+  def teardown
+    FileUtils.rm_rf(@dir)
+  end
+
+  def make_row(reason: "implementer_failed", stage: "4-execute",
+               message: "HTTP 401 Unauthorized missing bearer authentication",
+               id: "7", slug: "task-slug-260601-abcd")
+    folder = File.join(@dir, "task-#{id}")
+    FileUtils.mkdir_p(File.join(folder, "logs"))
+    File.write(File.join(folder, "logs", "run.log"), "#{message}\n")
+    state = File.join(folder, "task.md")
+    File.write(state, "<!-- ERROR reason=#{reason} marker_id=mid1 message=\"#{message}\" -->\n")
+    wt = File.join(@dir, "wt")
+    unless File.directory?(wt)
+      system("git", "init", "-q", wt)
+      system("git", "-C", wt, "config", "user.email", "t@e.com")
+      system("git", "-C", wt, "config", "user.name", "t")
+      File.write(File.join(wt, "f"), "x\n")
+      system("git", "-C", wt, "add", "f")
+      system("git", "-C", wt, "commit", "-qm", "i")
+    end
+    Row.new(
+      project: "demo", slug: slug, stage: stage, workflow: "coding",
+      marker: "error",
+      marker_attrs: { "reason" => reason, "marker_id" => "mid1", "message" => message },
+      folder: folder, state_file: state, live_task_lock: false, worktree_path: wt, id: id
+    )
+  end
+
+  def coordinator(enabled: true, healthy: true, health: nil)
+    Hive::Daemon::AutoRetry::Coordinator.new(
+      logger: @logger,
+      controller: FakeController.new,
+      state: @state,
+      health: health || FakeHealth.new(healthy: healthy),
+      request_queue: @queue,
+      enabled: enabled,
+      config_for_project: ->(_) { { "execute" => { "agent" => "codex" }, "claude" => { "mode" => "tmux" } } },
+      project_enabled: ->(_) { true },
+      legacy_projects: {}
+    )
+  end
+
+  def test_disabled_does_nothing
+    c = coordinator(enabled: false)
+    c.tick([ make_row ])
+    assert_empty @queue.requests
+    refute @logger.events.any? { |e| e[0] == :auto_retry_decision && e[1][:action] != "refuse" }
+  end
+
+  def test_healthy_codex_auth_queues_clear_and_sequence
+    c = coordinator(healthy: true)
+    c.tick([ make_row ])
+    assert_equal 1, @queue.requests.size
+    req = @queue.requests.first
+    assert_equal "auto_retry", req[:requestor]
+    assert_equal "clear", req[:recovery_step]
+    assert_includes req[:argv], "markers"
+    assert_includes req[:argv], "--recovery-id"
+    assert_equal 1, @queue.sequences.size
+    seq = @queue.sequences.values.first
+    assert_equal 1, seq[:argvs].size
+    refute_includes seq[:argvs].first, "markers"
+  end
+
+  def test_unhealthy_probe_refuses
+    c = coordinator(healthy: false)
+    c.tick([ make_row ])
+    assert_empty @queue.requests
+    decision = @logger.events.find { |e| e[0] == :auto_retry_decision }
+    assert decision
+    assert_equal "refuse", decision[1][:action]
+  end
+
+  def test_unknown_reason_never_queues
+    c = coordinator
+    row = make_row(reason: "dirty_worktree", message: "worktree dirty")
+    c.tick([ row ])
+    assert_empty @queue.requests
+  end
+
+  def test_finalize_never_touched
+    c = coordinator
+    row = make_row(stage: "8-finalize", reason: "claude_launch_failed",
+                   message: "claude interactive prompt did not become ready")
+    c.tick([ row ])
+    assert_empty @queue.requests
+  end
+
+  def test_markerless_restart_recreates_missing_rerun_request
+    row = make_row
+    c = coordinator
+    c.tick([ row ])
+    rec = @state.load_all.values.first
+    @state.upsert!(project: rec["project"], task_key: rec["task_key"], stage: rec["stage"],
+                   reason: rec["reason"], phase: "marker_cleared")
+    @queue.requests.clear
+    File.write(row.state_file, "")
+    markerless = Row.new(**row.to_h.merge(marker: "none", marker_attrs: {}))
+
+    coordinator.tick([ markerless ])
+
+    assert_equal 1, @queue.requests.size
+    assert_equal "rerun", @queue.requests.first[:recovery_step]
+    assert_equal rec["recovery_id"], @queue.requests.first[:recovery_id]
+    assert_equal "retry_queued", @state.load_all.values.first["phase"]
+  end
+
+  def test_sequence_failure_never_publishes_runnable_clear
+    @queue.fail_sequence = true
+
+    coordinator.tick([ make_row ])
+
+    assert_empty @queue.requests
+    assert @logger.events.any? { |name, _attrs| name == :auto_retry_sequence_error }
+  end
+
+  def test_dispatched_attempts_reconcile_to_failed_then_exhausted
+    row = make_row
+    key = Hive::Daemon::AutoRetry::State.task_key(task_id: row.id, slug: row.slug)
+    base = {
+      project: row.project, task_key: key, stage: row.stage, reason: "implementer_failed",
+      phase: "retry_dispatched", recovery_id: "ar-first", recovery_class: "codex_auth_401",
+      slug: row.slug, marker_id: "prior-marker", attempts_dispatched: 1
+    }
+    @state.upsert!(**base)
+
+    coordinator.tick([ row ])
+    assert_equal "failed", @state.load_all.values.first["phase"]
+
+    @state.upsert!(**base.merge(phase: "retry_dispatched", recovery_id: "ar-second",
+                                marker_id: "second-prior-marker", attempts_dispatched: 2))
+    coordinator.tick([ row ])
+    assert_equal "exhausted", @state.load_all.values.first["phase"]
+  end
+
+  def test_unhealthy_result_waits_for_fallback_cadence
+    health = FakeHealth.new(healthy: false)
+    c = coordinator(health: health)
+    row = make_row
+    now = Time.utc(2026, 7, 17, 12, 0, 0)
+
+    c.tick([ row ], now: now)
+    c.tick([ row ], now: now + 60)
+
+    assert_equal 1, health.probe_count
+    assert_empty @queue.requests
+  end
+
+  def test_probe_budget_rotates_so_later_candidates_are_not_starved
+    health = FakeHealth.new(healthy: false)
+    c = coordinator(health: health)
+    rows = [
+      make_row(id: "1", slug: "task-one-260601-abcd"),
+      make_row(id: "2", slug: "task-two-260601-abcd"),
+      make_row(id: "3", slug: "task-three-260601-abcd")
+    ]
+    now = Time.utc(2026, 7, 17, 12, 0, 0)
+
+    c.tick(rows, now: now)
+    assert_equal 2, health.probe_count
+    c.tick(rows, now: now + 60)
+    assert_equal 3, health.probe_count
+
+    records = @state.load_all.values
+    assert_equal 3, records.count { |record| !record["last_probe_at"].to_s.empty? }
+  end
+
+  def test_task_audit_preserves_false_probe_status_and_bounded_facts
+    c = coordinator(healthy: false)
+    row = make_row
+
+    c.tick([ row ])
+
+    event = File.readlines(File.join(row.folder, "events.jsonl"), chomp: true)
+                .map { |line| JSON.parse(line) }
+                .find { |entry| entry["event_type"] == "auto_retry_decision" }
+    probe = event.dig("details", "probes", 0)
+    assert_equal false, probe["ok"]
+    assert_equal false, probe["timed_out"]
+    assert_equal 0.25, probe["duration_sec"]
+    assert_equal "safe excerpt", probe["stdout"]
+    assert_equal row.id, event.dig("details", "task_id")
+    assert_equal "mid1", event.dig("details", "marker_id")
+    assert_equal 2, event.dig("details", "max_attempts")
+  end
+
+  def test_changed_health_fingerprint_reaches_second_attempt_and_exhaustion
+    health = FakeHealth.new(fingerprint: "fp-a")
+    c = coordinator(health: health)
+    row = make_row
+    t0 = Time.utc(2026, 7, 17, 12, 0, 0)
+
+    c.tick([ row ], now: t0)
+    first = @state.load_all.values.first
+    @state.upsert!(project: first["project"], task_key: first["task_key"],
+                   stage: first["stage"], reason: first["reason"], phase: "retry_queued")
+    @state.mark_dispatched!(project: first["project"], task_key: first["task_key"],
+                            stage: first["stage"], reason: first["reason"],
+                            fingerprint: "fp-a", recovery_id: first["recovery_id"])
+    failed_row = row_with_marker_id(row, "mid2")
+    c.tick([ failed_row ], now: t0 + 1)
+    assert_equal "failed", @state.load_all.values.first["phase"]
+    @queue.requests.clear
+    @queue.sequences.clear
+
+    health.fingerprint = "fp-b"
+    health.signal = "signal-fp-b"
+    c.tick([ failed_row ], now: t0 + 2)
+    assert_empty @queue.requests
+    assert_equal "fp-b", @state.load_all.values.first["second_candidate_fingerprint"]
+
+    c.tick([ failed_row ], now: t0 + 1_802)
+    assert_equal 1, @queue.requests.size
+    second = @state.load_all.values.first
+    refute_equal first["recovery_id"], second["recovery_id"]
+    assert_equal 1, second["attempts_dispatched"]
+
+    @state.upsert!(project: second["project"], task_key: second["task_key"],
+                   stage: second["stage"], reason: second["reason"], phase: "retry_queued")
+    @state.mark_dispatched!(project: second["project"], task_key: second["task_key"],
+                            stage: second["stage"], reason: second["reason"],
+                            fingerprint: "fp-b", recovery_id: second["recovery_id"])
+    c.tick([ row_with_marker_id(failed_row, "mid3") ], now: t0 + 1_803)
+    assert_equal "exhausted", @state.load_all.values.first["phase"]
+    assert_equal 2, @state.load_all.values.first["attempts_dispatched"]
+  end
+
+  def test_waiting_marker_is_authoritative_success_after_retry
+    row = make_row
+    key = Hive::Daemon::AutoRetry::State.task_key(task_id: row.id, slug: row.slug)
+    @state.upsert!(project: row.project, task_key: key, stage: row.stage,
+                   reason: "implementer_failed", phase: "retry_dispatched",
+                   recovery_id: "ar-success", recovery_class: "codex_auth_401",
+                   slug: row.slug, marker_id: "mid1", attempts_dispatched: 1)
+    waiting = Row.new(**row.to_h.merge(marker: "waiting", marker_attrs: {}))
+
+    coordinator.tick([ waiting ])
+
+    assert_equal "succeeded", @state.load_all.values.first["phase"]
+  end
+
+  def test_released_retry_request_stays_dispatchable_without_double_accounting
+    row = make_row
+    key = Hive::Daemon::AutoRetry::State.task_key(task_id: row.id, slug: row.slug)
+    retry_id = "retry-pending"
+    @state.upsert!(project: row.project, task_key: key, stage: row.stage,
+                   reason: "implementer_failed", phase: "retry_dispatched",
+                   recovery_id: "ar-released", recovery_class: "codex_auth_401",
+                   slug: row.slug, marker_id: "mid1", attempts_dispatched: 1,
+                   retry_request_id: retry_id)
+    @queue.requests << { request_id: retry_id, recovery_step: "rerun" }
+    markerless = Row.new(**row.to_h.merge(marker: "none", marker_attrs: {}))
+
+    coordinator.tick([ markerless ])
+
+    record = @state.load_all.values.first
+    assert_equal "retry_dispatched", record["phase"]
+    assert_equal 1, record["attempts_dispatched"]
+  end
+
+  def test_temporarily_absent_status_row_does_not_abort_inflight_recovery
+    row = make_row
+    key = Hive::Daemon::AutoRetry::State.task_key(task_id: row.id, slug: row.slug)
+    @state.upsert!(project: row.project, task_key: key, stage: row.stage,
+                   reason: "implementer_failed", phase: "marker_cleared",
+                   recovery_id: "ar-hidden", slug: row.slug)
+
+    coordinator.tick([])
+
+    assert_equal "marker_cleared", @state.load_all.values.first["phase"]
+  end
+
+  private
+
+  def row_with_marker_id(row, marker_id)
+    attrs = row.marker_attrs.merge("marker_id" => marker_id)
+    File.write(
+      row.state_file,
+      "<!-- ERROR reason=#{attrs['reason']} marker_id=#{marker_id} message=#{attrs['message'].inspect} -->\n"
+    )
+    Row.new(**row.to_h.merge(marker_attrs: attrs))
+  end
+end
